import { Type, ClassProperty } from "../Type";
import { TypeGraph } from "../TypeGraph";
import { Sourcelike } from "../Source";
import { Namer, Name } from "../Naming";
import { ConvenienceRenderer } from "../ConvenienceRenderer";
import { TargetLanguage } from "../TargetLanguage";
import { BooleanOption, Option } from "../RendererOptions";
export declare class JavaScriptTargetLanguage extends TargetLanguage {
    protected readonly omitRuntimeTypecheck: BooleanOption;
    constructor(displayName?: string, names?: string[], extension?: string);
    protected getOptions(): Option<any>[];
    readonly supportsOptionalClassProperties: boolean;
    protected readonly rendererClass: new (graph: TypeGraph, leadingComments: string[] | undefined, ...optionValues: any[]) => ConvenienceRenderer;
}
export declare class JavaScriptRenderer extends ConvenienceRenderer {
    private readonly _omitRuntimeTypecheck;
    constructor(graph: TypeGraph, leadingComments: string[] | undefined, _omitRuntimeTypecheck: boolean);
    protected topLevelNameStyle(rawName: string): string;
    protected makeNamedTypeNamer(): Namer;
    protected namerForClassProperty(): Namer;
    protected makeUnionMemberNamer(): null;
    protected makeEnumCaseNamer(): Namer;
    protected namedTypeToNameForTopLevel(type: Type): Type | undefined;
    protected emitDescriptionBlock(lines: string[]): void;
    typeMapTypeFor: (t: Type) => Sourcelike;
    typeMapTypeForProperty(p: ClassProperty): Sourcelike;
    emitBlock: (source: Sourcelike, end: string, emit: () => void) => void;
    emitTypeMap: () => void;
    protected deserializerFunctionName(name: Name): Sourcelike;
    protected deserializerFunctionLine(_t: Type, name: Name): Sourcelike;
    protected serializerFunctionName(name: Name): Sourcelike;
    protected serializerFunctionLine(_t: Type, name: Name): Sourcelike;
    protected readonly moduleLine: string | undefined;
    protected readonly castFunctionLine: string;
    protected readonly typeAnnotations: {
        any: string;
        anyArray: string;
        string: string;
        boolean: string;
    };
    private emitConvertModuleBody();
    protected emitConvertModule(): void;
    protected emitTypes(): void;
    protected emitUsageImportComment(): void;
    protected emitUsageComments(): void;
    protected emitModuleExports(): void;
    protected emitSourceStructure(): void;
}
